<?
/*
  Looty Debug - Why is Looty not working?
  =======================================
*/
$looty_debug_version = "1.0";

// set the content type to be text/plain. debugging is never fancy.
header('Content-type: text/plain');

// we're debugging so i want to see everything!
error_reporting(E_ALL ^ E_NOTICE);

$minlevel  = $_REQUEST['minlevel'];$maxlevel  = $_REQUEST['maxlevel'];
$expand    = $_REQUEST['expand'];
$char      = $_REQUEST['char'];
$filter    = $_REQUEST['filter'];
$itemclass = $_REQUEST['itemclass'];
$desc      = $_REQUEST['desc'];

// this is looty with bits taken out and some stuff added in.
// output is plain text to make it easy on my eyes
// taken from looty's index.php. thanks for the grand job fin!
// trell (trellin @ eu-runetotem, say hi if you see me online!)

// get the config
include './config.php';	

print "looty debug $looty_debug_version\n\n\n";

// connect to the db
include 'bits/dbsetup.inc';

// init some vars
$tdclasses = array(
	'item',
	'itemlight',
	);

$itemclasses = array(
	'#ffffff' => 'common',
	'#1eff00' => 'uncommon',
	'#0070dd' => 'superior',
	'#a335ee' => 'epic',
	);

$itemclassindex = array_flip($itemclasses);

if ($itemclass)
	$itemclass = $itemclassindex[$itemclass];

$money = array(
	'gold'		=> 0,
	'silver'	=> 0,
	'copper'	=> 0,
	);

if (!isset($expand) && $longdisplay)
	$expand	= true;

$guildname		= htmlspecialchars($guildname);
$guildname_plain	= $guildname;
$guildmaster		= htmlspecialchars($guildmaster);
$guildserver		= htmlspecialchars($guildmaster);

if ($guildurl)
	$guildname = "<a href='$guildurl'>$guildname</a>";

if (!empty($bankchars)) {
	foreach ($bankchars as $tmpchar => $tmpdesc) {
		if (!$bankchars[$tmpchar]) {
			unset($bankchars[$tmpchar]);
			}
		}
	}

if ($bankchar && empty($bankchars)) {
	$bankchars = array(
		$bankchar	=> 'Guild Bank',
		);
	}

if (!$bankchars) {
	$bankchars = array();
	die('No bank characters found - configure this setting in config.php');
	}

$allchars = $bankchars;

// reset $char if using different case
foreach ($bankchars as $tmpchar => $tmpdesc) {
	if (strtoupper($char) == strtoupper($tmpchar)) {
		$char = $tmpchar;
		}
	}

if ($char && $bankchars[$char]) {
	$tmpchar = $bankchars[$char];

	$bankchars = array(
		$char => $tmpchar,
		);
	}

$numlootchars = count($allchars);

print "BANKCHAR CONFIG\n";
print "There are $numlootchars configured.\n";
print_r($bankchars);
print "\n";

// get details of bank characters from the db
foreach ($bankchars as $tmpchar => $tmpdesc) {
	$quotedchars[]	= "'" . addslashes(strtoupper($tmpchar)) . "'";
	}

$sql	= "select * from {$dbprefix}players"
	. ' where upper(name) in (' . join(', ', $quotedchars) . ')';

print "The SQL used to search for them is:\n$sql\n\n";

$result	= mysql_query($sql); echo mysql_error();


// make sure we have some character data
if (!mysql_num_rows($result)) {
	die('Failed to get any player data from the database - check settings in config.php and whether CharacterProfiler is importing data correctly');
	}


// make a list of member ids, names, and money
while ($player = mysql_fetch_array($result, MYSQL_ASSOC)) {
	print $player['name'] . " is in the database as member id " . $player['member_id'] . "\n";
	$memberids[$player['name']]		= $player['member_id'];
	$membernames[$player['member_id']]	= $player['name'];

	$membermoney[$player['name']]['copper']	+= $player['money_c'];
	$membermoney[$player['name']]['silver']	+= $player['money_s'];
	$membermoney[$player['name']]['gold']	+= $player['money_g'];
	}

foreach ($membernames as $tmpmemberid => $tmpmembername) {
	foreach ($bankchars as $tmpbankcharname => $tmpbankchardesc) {
		if (strtoupper($tmpmembername) == strtoupper($tmpbankcharname) && ($tmpmembername != $tmpbankcharname)) {
			$bankchars[$tmpmembername] = $tmpbankchardesc;

			unset($bankchars[$tmpbankcharname]);
			}
		}
	}

// init the $wheres for the item select query
$wheres = array(
	"item_parent != 'bags'",
	'member_id in (' . join(', ', $memberids) . ')',
	);
print "\n\n";
if ($hidequest) {
	print "CONFIG: We're going to hide quests\n";
	$wheres[] = "item_parent != 'equip'";
}

if ($hidesoulbound) {
	print "CONFIG: We're going to hide soulbound items\n";
	$wheres[] = "item_tooltip not like '%Soulbound%'";
}

if ($hideequipped) {
	print "CONFIG: We're going to hide quest items\n";
	$wheres[] = "item_tooltip not like '%Quest Item%'";
}

if ($itemclass) {
	print "CONFIG: Only going to display items of class $itemclass\n";
	$tmpcolor = preg_replace('/^#/', '', $itemclass);
	print "      : That, by the way, means only show things that are $tmpcolor in colour\n";
	$wheres[] = "(item_color = '$tmpcolor' or item_color = 'ff$tmpcolor')";
}

if ($filter) {
	print "CONFIG: Only going to show things that match $filter\n";
	$wheres[]	= $searchtips
			? "(item_name like '%$filter%' or item_tooltip like '%$filter%')"
			: "item_name like '%$filter%'";
}

if (!isset($char))
	$char	= '';

if (isset($char)) {
	// set the default guild
	if (!$char)
		$guild	= '';

	// multi-guild stuff here a bit messy
	if ($guild && !empty($guildchars[$guild]))
		$bankcharnames = $guildchars[$guild];
	else
	// serves me right for starting something and dropping it halfway through
		$bankcharnames = array_keys($bankchars);

	foreach ($bankcharnames as $charname) {
		if ($memberids[$charname]) {
			$tmpmemberids[] = $memberids[$charname];

			$money['copper']	+= $membermoney[$charname]['copper'];
			$money['silver']	+= $membermoney[$charname]['silver'];
			$money['gold']		+= $membermoney[$charname]['gold'];
			}
		}

print "\n\nITEM SEARCH\n";
	$count	= 0;

	$sql	= "select * from {$dbprefix}items"
		. ($wheres ? ' where ' . join(' and ', $wheres) : '')
		. ($sort ? '' : ' order by item_name')
		;
print "\nSQL QUERY used for item search will be:\n\n$sql\n\n\n";
	$result	= mysql_query($sql); echo mysql_error();

print "\nitem colour:colour:index:name:amount:bank\n";

	while ($item = mysql_fetch_array($result, MYSQL_ASSOC)) {
		$index	= ++$count;

		$item['tooltip_orig']	= $item['item_tooltip'];

		if (preg_match('/Requires Level (\d+)/', $item['tooltip_orig'], $m))
			$item['level'] = $m[1];

		if ($minlevel && ($item['level'] < $minlevel))
			continue;

		if ($maxlevel && ($item['level'] > $maxlevel))
			continue;

		$item['index']		= $index;
		$item['name']		= $item['item_name'];
		$item['color']		= preg_replace((strlen($item['item_color']) == 8 ? '/^ff/' : '/^/'), '#', $item['item_color']);
		$item['class']		= $itemclasses[$item['color']];
		$item['amount']		= $item['item_quantity'];
		$item['player']		= $membernames[$item['member_id']];
		$item['icon']		= preg_replace('%\\\%', '/', $item['item_texture']);
		$item['htmlname']	= preg_replace('/ /', '&nbsp;', $item['name']);

		$item['tooltip']	= htmlspecialchars(stripslashes(trim($item['item_tooltip'])));
		$item['tooltip']	= preg_replace('/\s\n/', '&nbsp;', $item['tooltip']);
		$item['tooltip']	= trim(preg_replace("%(.+)\n%", "<span style='font-weight: bold; color: {$item['color']};'>{$item['htmlname']}</span>\n\n", $item['tooltip'], 1));

		$item['tooltip']	= preg_replace('/\|cf(......).([^|]+?)\|r/', "\n<span style='color: $1;'>$2</span>\n", $item['tooltip']);
		$item['tooltip']	= preg_replace('/Requires(.*)/', "\n<span style='color: red;'>Requires</span><span style='color: orange;'>\\1</span>", $item['tooltip']);
		$item['tooltip']	= preg_replace('/(Equip|Use)(.*)/', "\n<span style='color: #1EFF00;'>$1$2</span>", $item['tooltip']);
		$item['tooltip']	= preg_replace('/\n{2,}/', "\n\n", $item['tooltip']);

		$item['info']		= preg_split('/\n/', $item['tooltip'], -1, PREG_SPLIT_NO_EMPTY & PREG_SPLIT_DELIM_CAPTURE);

		array_shift($item['info']);
		array_shift($item['info']);

		$item['tooltip']	= nl2br($item['tooltip']);
		$item['tooltip_len']	= strlen($item['tooltip']);
print $item['item_color'] . ":" . $item['color'] . ":" . $index . ":" . $item['name'] . ":" . $item['amount'] . ":" . $item['player'] . "\n"; 
		if ($iconurlbase) {
			$iconurlbase	= preg_replace('%/+$%', '', $iconurlbase);
			$item['icon']	= "$iconurlbase/{$item['icon']}";
			}

		if (($existing = $itemnames[$item['name']]) && ($items[$existing]['player'] == $item['player'])) {
			$items[$existing]['amount'] += $item['amount'];
			}
		else {
			$itemnames[$item['name']] = $index;
			$items[$index] = $item;
			}
		}

	$total = count($items);

	if ($money['copper'] > 100) {
		$extrasilver		= floor($money['copper'] / 100);
		$money['silver']	+= $extrasilver;
		$money['copper']	-= 100 * $extrasilver;
		}

	if ($money['silver'] > 100) {
		$extragold		= floor($money['silver'] / 100);
		$money['gold']		+= $extragold;
		$money['silver']	-= 100 * $extragold;
		}
	}

function pre($var) { echo '<pre>'; print_r($var); echo '</pre>'; }

function init_sort($items, $field, $reverse) {
	uksort($items, create_function('$a, $b', 'if ($a == $b) return 0; return strcmp($a[\'' . $field . '\'], $b[\'' . $field . '\']);'));
	
	return $reverse ? array_reverse($items, true) : $items;
	}

function sort_items($unsorted=array(), $sort='', $desc=false) {
	global $itemclasses;

	if (empty($unsorted))
		return array();

	$count = 0;

	foreach ($unsorted as $index => $item) {
		$sorted[$item['player']][++$count] = $item;
		}

	if ($sort) {
		// sort by given field
		foreach ($sorted as $char => $items) {
			$sorted[$char] = init_sort($items, $sort, $desc);
			}
		}
	else {
		// sort by class
		foreach ($sorted as $char => $items) {
			foreach ($items as $index => $item) {
				$tmpitems[$char][$item['class']][++$count] = $item;
				}
			}

		foreach ($tmpitems as $char => $itemsbyclass) {
			foreach ($itemclasses as $tmpclass) {
				if (empty($tmpitems[$char][$tmpclass]))
					continue;

				foreach ($tmpitems[$char][$tmpclass] as $newitem) {
					$tmpsorted[$char][++$count] = $newitem;
					}
				}
			}

		$sorted = $tmpsorted;
		}

	return $sorted;
	}

$oldsort = $sort;

if (!$desc && ($sort == $oldsort))
	$oldsort .= "&desc=1";

print "RAW DUMP\n\n";
print "\nITEMS PRE-SORT\n\n";
print_r($items);
$items = sort_items($items, $sort, $desc);
print "\n\n\n\nITEMS POST-SORT\n";
print_r($items);

print "LOOTY has completed. Hurrah.\n"
?>
